
{
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses
}


{
TODO:
neni osetreno Not enought disk space
Predelat na dynamicke promenne! Mozna nekdy, nebo spis nikdy.:)

prototyp: ceka jen na to aby se vyresilo automaticke posouvani kurzoru -
pokud se zapise na posledni znak radky automaticky odscroluje :(}

{ Adam Pribyl, pribyl@lowlevel.cz, 1995-2013 }

{$M $8000,$2000,$3000}   { 32K stack, min heap 8K, max 12k}

Program TurboEdit (input,output);

uses Crt,Dos,Strings,Graph;

type
 POneRec=^onerec;
 onerec = record
            tretez:string[20];
            dalsi:POneRec;
           end;

label
 1;

const
 kradku=80;
 knavesti:byte=10;
 kinstr:byte=18;
 koperand:byte=40;
 zradku:byte=1;
 hled_retez=10;
{$IFDEF MSDOS}
 lomitko:string='\';
{$ELSE}
 lomitko:string='/';
{$ENDIF}


var
{ block_p:pointer; pointer na blok alokovany dynamicky}
 f:integer;
 cursorpos,i:byte;
 num_line:integer;      {Num_line= cislo prvni radky na obr. editline=num_line+10 : je to este pravda?}
 end_line:integer;
 hod,min,s,ss:word;
 soubor:text;
 block:text;
 jmeno:string;
 userfname:array[1..12] of char;
 pomufn:string[12];
 {a,}done,pisb,overwrite,contvz:boolean; {komnet,uvoz}
 Ch,Ch2:char;
 radka,pomradka:array[1..kradku] of char;
 chyba,inlinecom:byte;
 radkains:string;
 sysdir,workdir:string;
 cmdtasm,cmdtlink,cmdtd:string;
 jinstdtb:string;
 instdtb:text;
 posledni:array[1..10] of byte; {posledni polozka menu}
 cohled:string[hled_retez+2];	{2=>misto pro #13}
 block_b:integer;
 block_k:integer;
 edtypt:boolean;
 poinstset:POneRec;
{ i: TShiftState;}

function MINUTY(w:word):string;
 var
  s:string;
 begin
  str(w:0,s);
  if length(s)=1 then s:='0'+s;
  MINUTY:=s;
 end;

function RadkaCh(tradka:string;posn:integer):boolean;forward;

procedure C_Radku;
 begin
  TextColor(Red);
  GotoXY(64,1);
  write(num_line,':',cursorpos,'  '); {dva rady smazat by meli na radce stacit}
  TextColor(white)
 end;

function OdstLom(uceho:string):string;
var ln:integer;

begin
 ln:=length(uceho);
 OdstLom:=uceho;
 if (uceho[ln]=lomitko) and (uceho[ln-1]<>':') then OdstLom[0]:=chr(ln-1);
end;

procedure TimeObr;
{var x,y:byte;}
 begin
  Textcolor(white);
  GetTime(hod,min,s,ss);
  GotoXY(76,1);
  write(hod,':',MINUTY(min));
 end;

procedure SmazInfo;
{var i:byte;}
begin
 TextColor(7);
 TextBackGround(0);
 HighVideo;
 GoToXY(1,1);
 write('                                                                               ')
{ for i:=1 to 80 do write(' ');}
end;
procedure OverIns; forward;
procedure Inforadek;
begin
 SmazInfo;
 TextColor(7);
 LowVideo;
 GotoXY(45,1);
 write(userfname);
 OverIns;
 C_Radku;
 TimeObr;
end;


procedure WaitKey;
begin
 repeat
  TimeObr;
 until KeyPressed;
 Ch:=ReadKey;
 if Ch=#0 then Ch:=ReadKey;
end;

procedure Error(cislo:byte);
begin
 TextColor(7);
 TextBackGround(0);
 HighVideo;
 SmazInfo;
 GotoXY(1,1);
 case cislo of
   1: write('Comment too long');
  23: write('Bad input');
   2: write('File not found');
   3: write('Path not found');
   4: write('File name too long');
   5: write('Acces denied');
   6: write('Invalid handle');
  24: write('Disk writing error');
  20: write('Help file not found');
  22: write('Cannot change directory');
   8: write('Not enough memory');
  25: write('Cannot make work directory');
   9: write('Cannot make temp file');
  10: write('Invalid environment');
  11: write('Invalid format');
  12: write('String not found');
  18: write('No more files');
{Moje}
  40: write('Config file "tasme.cfg" missing');
  41: write('[ASM] section in config "tasme.cfg" missing');
  42: write('[LINK] section in config "tasme.cfg" missing');
  43: write('[DEBUG] section in config "tasme.cfg" missing');
 else write('Unknown error!')
 end;
 Sound(880);
 Delay(200);
 NoSound;
 WaitKey;
 Inforadek;
 chyba:=0;
end;

procedure OverIns;
begin
 TextColor(Blue);
 GoToXY(60,1);
 if overwrite then write('O')
 else write('I');
 TextColor(White)
end;

procedure Obrazovka;
begin
  TextBackground(Black);
  TextColor(White);
  HighVideo;
  ClrScr;
  InfoRadek;
  GotoXY(1,2);
  write ('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');
  GotoXY(1,24);
  write ('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');
end;

procedure ObarvRad(inrad:string; Yposition:integer);forward;

procedure Vypis(how:integer);
var zac,radekprecist:integer;
    cradka:string[kradku];

procedure PosNahoru; { interni procedura Vypis }
begin
  InfoRadek;
  for f:=zac to 23 do
  begin
    case f of
      12: begin
           Window(1,3,80,12);
           GotoXY(1,1);
           DelLine;
           Window(1,12,80,13);
           GotoXY(1,1);
           readln(soubor,cradka);
           ObarvRad(cradka,1);
           Window(1,1,80,25);
          end;
      13: begin
           TextColor(7);
{           TextBackground(White);
           HighVideo;}
           readln(soubor,cradka);
           GotoXY(1,13);
{           write(cradka);}{ignoruje znaky za 80znakem}
           ObarvRad(cradka,13);
           TextBackground(White);
           for i:=length(cradka) to kradku-1 do
            write(' ');
           TextBackground(Black);
{           LowVideo;}
          end;
      23: begin
           Window(1,14,80,23);
           GotoXY(1,1);
           DelLine;
           Window(1,23,80,24);
           GotoXY(1,1);
           readln(soubor,cradka);
           ObarvRad(cradka,1);
           Window(1,1,80,25);
          end;
      else
       if not eof(soubor) then
       begin
        readln(soubor,cradka);
{        ObarvRad(cradka);}
{        write(cradka);}{ignoruje znaky za 80znakem}
{        writeln;}
       end { else }
    end { case f of }
   end {for}
end;

procedure PosDolu; { interni procedura Vypis }
begin
  InfoRadek;
  for f:=zac to 23 do
  begin
{   gotoxy(1,zac);write('jsdkfkjdsfd');}
    if (f=zac) and (f<>13) then
    begin
           Window(1,3,80,12);
           GotoXY(1,1);
           InsLine;
           window(1,1,80,25);
           GotoXY(1,zac);
           readln(soubor,cradka);
           ObarvRad(cradka,zac);
{           Window(1,1,80,25);}
    end
    else
    begin
      if (f=zac) and (f=13) then
      begin
           Window(1,3,80,12);
           GotoXY(1,1);
           InsLine;
           window(1,1,80,25);
      end;

      case f of
       13: begin
           TextColor(7);
{           TextBackground(White);
           HighVideo;}
           readln(soubor,cradka);
           GotoXY(1,13);
           ObarvRad(cradka,13);
           TextBackground(White);
{           write(cradka);}{ignoruje znaky za 80znakem}
           for i:=length(cradka) to kradku-1 do
            write(' ');
           TextBackground(Black);
{           LowVideo;  }
          end;
       14: begin
           Window(1,14,80,23);
           GotoXY(1,1);
           InsLine;
           GotoXY(1,1);
           readln(soubor,cradka);
           ObarvRad(cradka,1);
           Window(1,1,80,25);
          end;
       else
       begin
        if not eof(soubor) then
        begin
         readln(soubor,cradka);
        end;
       end; { else }
       end; { case }
    end; { if f<>13 }
   end; { for }
end;

procedure VypRad; { interni procedura Vypis }
var i{,pocpro,poc2}:byte;
begin
  Obrazovka;
  Lowvideo;
  for f:=zac to 23 do
  begin
    GotoXY(1,f);
    if f=13 then
    begin
{      TextColor(7);
      TextBackground(White);
      HighVideo;
        readln(soubor,cradka);
        write(cradka);}{ignoruje znaky za 80znakem}
      readln(soubor,cradka);
{      HighVideo;}
      ObarvRad(cradka,f);
      TextBackground(White);
      for i:=length(cradka) to kradku-1 do
       write(' ');
      TextBackground(Black);
{      LowVideo;}
    end
    else
    begin
      if not eof(soubor) then
      begin
         readln(soubor,cradka);
         ObarvRad(cradka,f);
{         write(cradka);} {ignoruje znaky za 80znakem}
{         if length(cradka) < 80 then}
          writeln;
      end;
      TextBackground(Black);
    end;
  end;
end;

begin { procedura Vypis }
  Reset(soubor);
  if num_line<>1 then
  begin
   zac:=3;
   if num_line-11<1 then
   begin
     radekprecist:=0;
     zac:=14-num_line
   end
   else radekprecist:=num_line-11;
   for f:=1 to radekprecist do
     readln(soubor,cradka);
   case how of
       1: VypRad;
       2: PosNahoru;
       3: PosDolu;
   end;
  end
  else
  begin
   zac:=13;
   case how of
      1: VypRad;
      2: PosNahoru;
      3: PosDolu;
   end
  end;
  Close(soubor);
end;


procedure ObarvRad(inrad:string; Yposition:integer);
var pomstr:string;
    pocit:integer;
    lokKradku:integer;

 procedure WriteToCorner (c:char);
 begin
  Inc(WindMax);
  GotoXY(80, 25);
  write(c);
  Dec(WindMax);
 end;

begin
 if Yposition=25 then
  lokKradku:=kradku-1
 else
  lokKradku:=kradku;

 inrad:=inrad+#0;
 pocit:=0;
 if ((num_line+f-13)>=block_b) and ((num_line+f-13)<=block_k) and (block_b<=block_k) and (f<>13)
  then TextBackground(Blue)
 else
  if f<>13 then TextBackground(Black)
  else TextBackground(White);
 repeat
  inc(pocit);
  pomstr:='';
  while ((inrad[pocit]=' ') or (inrad[pocit]=#9)) and (pocit<=lokKradku) do
  begin
    if inrad[pocit]=#9 then inrad[pocit]:=' ';
    pomstr:=pomstr+inrad[pocit];
    inc(pocit)
  end;
  while (inrad[pocit]<>' ') and (inrad[pocit]<>#0) and (inrad[pocit]<>#9) and (pocit<=lokKradku) do
  begin
    if inrad[pocit]=#9 then inrad[pocit]:=' ';
    if inrad[pocit]<>#0 then pomstr:=pomstr+inrad[pocit];
    inc(pocit)
  end;
  if inrad[pocit]=#9 then inrad[pocit]:=' '; { replace Tab by space }
  if ((inrad[pocit]<>#0) and (pocit<>80)) then pomstr:=pomstr+inrad[pocit];
  if RadkaCh(inrad,pocit) then
  begin
    if f<>13 then TextColor(green)
    else TextColor(white);
    write(pomstr);
  end
  else
  begin
    Textcolor(white);
    write(pomstr)
  end;
  if ((Yposition=25) and (pocit=80)) then
   WriteToCorner(inrad[pocit])
 until (pocit>=kradku) or (inrad[pocit]=#0);

 i:=pocit; {pro Vypcur}
 TextBackground(Black); {pro Vypcur}
end;

procedure ORadekVys;
 begin
  if num_line>1 then
   begin
    dec(num_line);
    Vypis(3);
   end;
 end;

procedure ORadekNiz;
 begin
   if num_line<end_line then
    begin
     inc (num_line);
{     Vypis;}
     Vypis(2);
    end
 end;


procedure Vypcur;{vypis cursor a radek}
begin
   Window(1,25,80,25);
   GoToXY(1,1);
   f:=block_k;          {f je v tomto pripade irelevatni}
   block_k:=0;          {kuli tomu aby ObarvRad "neoblokovaval" editovany radek}
   ObarvRad(radka,25);
   textbackground(green);
   clreol;
   block_k:=f;
{   while i<=kradku do
    begin
     write(' ');
     inc(i)
    end;}
{   write(radka);}
   if radka[cursorpos]<>#9 then Ch:=radka[cursorpos]
   else Ch:=' ';
   GoToXY(cursorpos,1);
   TextBackground(red);
   write(Ch);
   TextBackground(Black);
   Window(1,1,80,25);
end;

procedure Doprava;
begin
{ if cursorpos<kradku and cursorpos< then
  begin
   if radka[cursorpos]=#0 then radka[cursorpos]:=' ';
   inc(cursorpos);
  end}
 if (cursorpos<kradku) and (radka[cursorpos]<>#0) then inc(cursorpos);
end;

function Komentar(radka:string;posn2:integer):boolean;
var pocu,f:integer;
    pom:boolean;

begin
if contvz {and (inlinecom=0)} then
begin
 pocu:=0;
 pom:=false;
 for f:=posn2 downto 1 do
  if radka[f]=';' then
   begin
    komentar:=true;
    pom:=true;
    {f:=1;}
    break;
   end
  else komentar:=false;
 if not pom then
  begin
   for f:=posn2 downto 1 do
    if radka[f]='''' then inc(pocu);
   if (pocu/2)<>(pocu div 2) then komentar:=true
    else komentar:=false;
  end
end
else komentar:=true;
end;


function Komentar2(radka:string;posn2:integer):boolean;
var pocu,f:integer;
    pom:boolean;

begin
if contvz and (inlinecom=0) then
begin
 pocu:=0;
 pom:=false;
 for f:=posn2 downto 1 do
  if radka[f]=';' then
   begin
    komentar2:=true;
    pom:=true;
    {f:=1;}
    break;
   end
  else komentar2:=false;
 if not pom then
  begin
   for f:=posn2 downto 1 do
    if radka[f]='''' then inc(pocu);
   if (pocu/2)<>(pocu div 2) then komentar2:=true
    else komentar2:=false;
  end
end
else komentar2:=true;
end;


procedure Doleva;
begin
 if cursorpos>zradku then
 begin
  dec(cursorpos);
  if not komentar(radka,cursorpos) then pisb:=true
 end
end;


procedure Strednik;
begin
 if (radka[kradku]=#0) or (radka[kradku]=' ')  then
  begin
   for i:=cursorpos to kradku do
    begin
     Ch2:=radka[i]; radka[i]:=Ch;
     Ch:=Ch2
    end
  end
 else pisb:=false;
end;

procedure Tabulator;
begin
 if cursorpos=kradku then begin Sound(330); Delay(50); NoSound; end;
 if inlinecom=0 then
 begin
 if komentar(radka,cursorpos) and pisb and (cursorpos<kradku) then
  begin
   Ch:=' ';
   Strednik;
   inc(cursorpos);
  end;
{ if komentar(radka,cursorpos) and pisb then inc(cursorpos);}
 if not komentar(radka,cursorpos) then
 begin
  if (cursorpos>koperand) and (cursorpos<kradku) then
   begin
    radka[cursorpos]:=' ';
    inc(cursorpos)
   end;
  if (cursorpos>kinstr) and (cursorpos<=koperand) then
   begin
    for f:=cursorpos to koperand do
     if radka[f]=#0 then radka[f]:=' ';
    cursorpos:=koperand+1
   end;
  if (cursorpos>knavesti) and (cursorpos<=kinstr) then
   begin
    for f:=cursorpos to kinstr do
     if radka[f]=#0 then radka[f]:=' ';
    cursorpos:=kinstr+1
   end;
  if cursorpos<=knavesti then
   begin
    for f:=cursorpos to knavesti do
     if radka[f]=#0 then radka[f]:=' ';
    cursorpos:=knavesti+1;
   end
  end
 end;
end;

{procedure Mezernik;
begin
 if inlinecom=0 then
 begin
 if komentar(radka,cursorpos) and pisb then
  begin
   Ch:=' ';
   Strednik;
   inc(cursorpos);
  end;}
{ if komentar(radka,cursorpos) and pisb then inc(cursorpos);}
{ if not komentar(radka,cursorpos) then
  begin
   if cursorpos>kinstr then
    begin
     radka[cursorpos]:=' ';
     inc(cursorpos);
    end
  end
 end
end;}

procedure DelRadek;
begin
 pisb:=true;
 for f:=1 to kradku do radka[f]:=#0;
 cursorpos:=1;
 Vypcur;
 InfoRadek;
 inlinecom:=0;
 zradku:=1;
end;

procedure Editln;
var poc2:integer;
    dummyradka:string;
begin
 overwrite:=true;
 inlinecom:=0;
 OverIns;
 pisb:=true;
 cursorpos:=1;
 for f:=1 to kradku do radka[f]:=#0;
 Reset(soubor);
 for f:=1 to num_line-1 do
  begin
{   while not eoln(soubor) do
    read(soubor,Ch);}
{   read(soubor,Ch);}{CR}
{   read(soubor,Ch);}{LF}
    readln(soubor,dummyradka);
  end;
 f:=1;
 poc2:=0;
 while not eoln(soubor) and (poc2<kradku) do
  begin
   read(soubor,Ch);
   radka[f]:=Ch;
   inc(f);
   inc(poc2)
  end;
 Close(soubor);
end;

procedure HelpPage;
var radkacel:string;
    help:text;
begin
 radkacel:=sysdir+'tehelp.hlp';
 Assign(help,radkacel);
 {$I-}
  Reset(help);
 {$I+}
 if IOResult=0 then
  begin
   TextColor(7);
   TextBackGround(0);
   HighVideo;
   ClrScr;
   repeat
    readln(help,radkacel);
    writeln(radkacel)
   until eof(help);
   WaitKey;
   Vypis(1);
   Close(help);
  end
 else
  begin
   Error(20);
   Vypis(1);
  end;
end;


procedure Backspace;
begin
 if cursorpos>zradku then
  begin
   for f:=cursorpos to kradku do
    begin
     Ch:=radka[f]; radka[f-1]:=Ch;
    end;
   radka[kradku]:=#0;
   dec(cursorpos);
   pisb:=true;
   if not komentar(radka,cursorpos) then Vypcur;
  end
end;

procedure Del;
begin
 if cursorpos>=zradku then
 begin
  for f:=cursorpos to (kradku-1) do
   begin
    Ch:=radka[f+1]; radka[f]:=Ch;
   end;
  radka[kradku]:=#0;
  pisb:=true;
  if not komentar(radka,cursorpos) then RadkaCh(radka,cursorpos);
 end;
end;

procedure ContUprav;
var instrukce:array [1..kradku] of char;
    operandy:array [1..kradku] of char;
    {comment:array [1..kradku] of char;}
    chybi,chybo:boolean;
{    schov:integer;}
begin
if contvz then
begin
 pomradka:=radka;
   chybi:=false;
   chybo:=false;
   f:=0;
   for i:=(knavesti+1) to kinstr do
    instrukce[i]:=#0;
   for i:=(kinstr+1) to koperand do
    operandy[i]:=#0;
   repeat
     inc(f);
   until (radka[f]=' ') or (f=knavesti) or (radka[f]=#0) or (radka[f]=';') or (radka[f]=#9);
   if radka[f]=';' then dec(f);
   repeat
    inc(f);
   until (radka[f]<>' ') or (radka[f]=';') or (radka[f]=#0) or (radka[f]=#9);
   if (radka[f]=';') or (radka[f]=#0) then chybi:=true;
   if not chybi then
    begin
     i:=knavesti+1;
     repeat
      instrukce[i]:=radka[f];
      radka[f]:=' ';
      inc(f);
      inc(i);
     until (radka[f]=' ') or (radka[f]=#0) or (i=kinstr) or (radka[f]=#9);
    end;
   if not chybi then
    begin
     repeat
      inc(f);
     until (radka[f]<>' ') or (radka[f]=';') or (radka[f]=#0) or (radka[f]=#9);
     if (radka[f]=';') or (radka[f]=#0) then chybo:=true;
     if not chybo then
      begin
       i:=kinstr+1;
       repeat
        operandy[i]:=radka[f];
        radka[f]:=' ';
        inc(f);
        inc(i);
       until (radka[f]=';') or (radka[f]=#0) or (i=koperand) or (radka[f]=#9);
{       if i=koperand then if radka[koperend+1]>=' ' then begin chyba:=3; exit; end;}
       if radka[f]<>';' then
        repeat
         inc(f);
        until (radka[f]=';') or (radka[f]=#0) or (f>koperand);
      end;
      if radka[f]=';' then
       begin
        Ch:=' ';
        while f<(koperand+1) do
         begin
          cursorpos:=f;
          if (radka[kradku]<>#0) then radka[kradku]:=#0; {odsekne komentar jestlize je delsi nez povoleny}
          Strednik;
          inc(f);
         end;
       end;
     end;
    if not chybi then
     begin
      for f:=(knavesti+1) to kinstr do
       begin
        if (instrukce[f]>='a') and (instrukce[f]<='z') then
         instrukce[f]:=chr(ord(instrukce[f])-32);
        radka[f]:=instrukce[f];
       end;
      if not chybo then
       for f:=(kinstr+1) to koperand do
        radka[f]:=operandy[f];
     end;
    for f:=1 to kradku do
     if (ord(radka[f])<32) then radka[f]:=' ';
end;
  for f:=1 to kradku do
   if (radka[f]=#0) then radka[f]:=' ';
  pomradka:=radka;
  DelRadek;
end;

procedure NajdiEnd;
var radkacel:string;
begin
 end_line:=1;
 repeat
  readln(soubor,radkacel);
  inc(end_line);
 until eof(soubor);
 dec(end_line);
end;

procedure ChgOI;
begin
 if overwrite then overwrite:=false
  else overwrite:=true;
 OverIns;
end;

procedure DelInsRadek(cislop:byte);
var soubor2:text;
    radkadel:string;
{    buf1:array[1..5120]of char;
    buf2:array[1..5120]of char; }

begin
 radkadel:=sysdir+'tedit$$$.tmp';
 Assign(soubor2,radkadel);
 Rewrite(soubor2);
 {$I-}
 Reset(soubor);
 {$I+}
 if IOResult=0 then
 begin
{ SetTextBuf(soubor,buf);} {NEZAPIINAT BUFFER=>CHYBNE
 SetTextBuf(soubor2,buf); ZPRACOVANI RADKU!!!!!!!!}
{!!! buffer se musi definovat ke kazdemu souboru zvlast !!! pak to funguje}
{ SetTextBuf(soubor,buf1);
 SetTextBuf(soubor2,buf2);
 Ani toto neni resenim! Nastava zahadna chyba po teto sequenci:
 F10, Load, libovolny soubor, Alt+d, F10, Esc
 chyba nastane na fci eof(soubor) v procedure VypRad.}
 for f:=1 to num_line-1 do
  begin
   readln(soubor,radkadel);
   writeln(soubor2,radkadel);
  end;
{1 smaz radekdel
 2 vloz radekins
 3 prepis radekdel radkemins}
 case cislop of
  1: readln(soubor,radkadel);
  2: begin
      readln(soubor,radkadel);
      writeln(soubor2,radkadel);
      writeln(soubor2,radkains);
     end;
  3: begin
      readln(soubor,radkadel);
      writeln(soubor2,radkains);
     end;
 end;
 while not eof(soubor) do
  begin
   readln(soubor,radkadel);
   writeln(soubor2,radkadel);
  end;
 Rewrite(soubor);
 Reset(soubor2);
 repeat
  readln(soubor2,radkadel);
  writeln(soubor,radkadel);
 until eof(soubor2);
 Close(soubor2);
 Erase(soubor2);
 Close(soubor);
 case cislop of
  1: begin
      dec(end_line);
      if (num_line>=block_b) and (num_line<=block_k) then block_k:=block_k-1
       else if num_line<block_b then
             begin
              block_b:=block_b-1;
              block_k:=block_k-1;
             end;
      if end_line+1=num_line then dec(num_line);
      Vypis(1);
     end;
  2: begin
      inc(end_line);
      if (num_line>=block_b) and (num_line<=block_k) then block_k:=block_k+1
       else if num_line<block_b then
             begin
              block_b:=block_b+1;
              block_k:=block_k+1;
             end;
      if num_line<end_line then inc (num_line);
      Vypis(1);
     end;
  3: Vypis(1);
 end
 end
 else Error(24);
end;

procedure SmazLine;
begin
 if end_line<>1 then
  DelInsRadek(1);
end;

procedure UpravRadku;
begin
 radkains:=pomradka;
 f:=kradku;
 while (f>=0) and (radkains[f]=' ') do dec(f);
{ until (f<0) or (radkains[f]<>' ');}{ or (radkains[f]<>#0);f<0 by nemuselo byt=vprvnim znaku bude u pradneho radku 0}
                                                        {#0 kuli modu bez upravy textu}
{ inc(f);}
  radkains[0]:=chr(f);
end;

function SureQue(what:string):boolean;
begin
 InfoRadek;
 GoToXY(1,1);
 write('Are you sure? ',what,'?');
 Sound(550); Delay(40); NoSound;
 WaitKey;
 if (Ch='y') or (Ch='Y') then SureQue:=true
  else SureQue:=false;
 InfoRadek;
end;

procedure Hlaseni(what:string);
begin
 GoToXY(1,1);
 write(what)
end;


procedure DefPolozky2;forward;
procedure Load2;forward;
procedure Save2;forward;
procedure ZmenDir2;forward;
procedure SpustTasm2;forward;
procedure SpustTlink2;forward;
procedure Hledej2;forward;
procedure SpustExe2;forward;
procedure SpustTd2;forward;

procedure Enter;
begin
 if inlinecom=0 then
 if overwrite then
  begin
   overwrite:=false;
   OverIns;
   ContUprav;
   UpravRadku;
   DelInsRadek(3);
   {(vymazani) posunuti zapsani(s CR a LF)}
  end
 else
  begin
   ContUprav;
   UpravRadku;
   DelInsRadek(2);
  end
 else
  case inlinecom of
   1:DefPolozky2;
   2:Load2;
   3:Save2;
   4:ZmenDir2;
   5:SpustTasm2;
   6:SpustTlink2;
   7:Hledej2;
   8:SpustExe2;
   9:SpustTd2;
  end;
end;

procedure InputRad(polozka:string); forward;
procedure ZpracInp; forward;
procedure CopyBlock; forward;
procedure Cursor (visible:boolean); forward;

procedure RunProg(prog:string;CmdLine:string);
begin
 ClrScr;
 Hlaseni('Exec:');
 writeln;
 writeln(Prog+cmdline);
 LowVideo;
 Cursor(true);
{ delay(400);}
 SwapVectors;
 Exec(Prog,CmdLine);
 SwapVectors;
 HighVideo;
 Cursor(false);
 writeln('Press any key...');
 WaitKey;
 ClrScr;
{ Hlaseni('...back from Exec');
 writeln;
 delay(600);
 SmazInfo;}
 if DosError <> 0 then{ Error? }
  begin
   Error(DosError);
  end
 else
  begin
   CmdLine:='Exec successful.';
   Hlaseni(CmdLine);
   writeln;
   delay(400);
  end;
end;

procedure SubRut2(var CmdLine:string;var pomprom:string;pripona:string);
{var pomprom:string[11];}
begin
 pomprom:='';
 f:=0;
 repeat
  inc(f);
 until radka[f]=':';
 if radka[f+1]<>#0 then
  begin
   i:=0;
   repeat
    inc(f);
    inc(i);
    CmdLine[i]:=radka[f];
   until radka[f]=#0;
   CmdLine[0]:=chr(i-1);
  end
 else CmdLine:='';
 f:=0;
 repeat
  inc(f);
  pomprom[f]:=userfname[f];
 until (userfname[f]='.') or (f=12);
 pomprom[0]:=chr(f);
 pomprom:=pomprom+pripona;
end;

function Cfg(what:string):string;
var radcfg:string;
    config: text;

begin
 Assign(config,sysdir+'tasme.cfg');
{$I-}
 Reset(config);
{$I+}
 if IOResult<>0 then
  begin
   Error(40);
   Cfg:=' ';
  end
 else
  begin
   repeat
    readln(config, radcfg);
   until (radcfg=what) or eof(config);
   if eof(config) then
    begin
     if what='[ASM]' then Error(41);
     if what='[LINK]' then Error(42);
     if what='[DEBUG]' then Error(43);
     Cfg:=' ';
    end
   else
    begin
     readln(config, radcfg);
      Cfg:=radcfg;
    end
  end;
 Close(config);
end;

procedure SpustTasm;
var strpin: string;
begin
 strpin:='ASM:';
 strpin:=strpin+cmdtasm;
 InputRad(strpin);
 inlinecom:=5;
 zradku:=length(strpin)+1-length(cmdtasm);
{ zradku:=length(strpin)+1;}
end;

procedure SpustTasm2;
var CmdLine:string;
    pomprom:string;

begin
 if edtypt then SubRut2(CmdLine,pomprom,'obj')
 else SubRut2(CmdLine,pomprom,'');
 cmdtasm:=CmdLine;
 if edtypt then CmdLine:=CmdLine+' '+jmeno+' '+workdir+pomprom;
 pomprom:=Cfg('[ASM]');
 if pomprom<>'' then RunProg(pomprom+' ',CmdLine);
 DelRadek;
 Vypis(1);
end;

procedure SpustTlink;
var strpin: string;
begin
 strpin:='LINK:';
 strpin:=strpin+cmdtlink;
 InputRad(strpin);
 inlinecom:=6;
 zradku:=length(strpin)+1-length(cmdtlink);
end;

procedure SpustTlink2;
var CmdLine:string;
    pomprom:string;
begin
 if edtypt then SubRut2(CmdLine,pomprom,'obj')
 else SubRut2(CmdLine,pomprom,'');
{ SubRut2(CmdLine,pomprom,'obj');}
 cmdtlink:=CmdLine;
 if edtypt then CmdLine:=Cmdline+' '+workdir+pomprom;
 pomprom:=Cfg('[LINK]');
 if pomprom<>'' then RunProg(pomprom+' ',CmdLine);
 DelRadek;
 Vypis(1);
end;

procedure SpustTd;
var strpin: string;
begin
 strpin:='DEBUG:';
 strpin:=strpin+cmdtd;
 InputRad(strpin);
 inlinecom:=9;
 zradku:=length(strpin)+1-length(cmdtd);
end;

procedure SpustTd2;
var CmdLine:string;
    pomprom:string;
begin
 SubRut2(CmdLine,pomprom,'');
 pomprom[0]:=chr(Length(pomprom)-1);
 cmdtd:=CmdLine;
 if edtypt then CmdLine:=Cmdline+' '+workdir+pomprom;
 pomprom:=Cfg('[DEBUG]');
 if pomprom<>'' then RunProg(pomprom+' ',CmdLine);
 DelRadek;
 Vypis(1);
end;

procedure Load;
var strpin:string;
begin
 strpin:='LOAD ('+userfname+'):';
 InputRad(strpin);
 inlinecom:=2;
 zradku:=length(strpin)+1;
end;

procedure Load2;
var soubor2:text;
    radkacel:string;
begin
 ZpracInp;
 if chyba=0 then
  begin
   Assign(soubor2,workdir+userfname);
   {$I-}
    Reset(soubor2);
   {$I+}
   if IOResult=0 then
    begin
     Hlaseni('Loading...');
     Rewrite(soubor);
     readln(soubor2,radkacel);
     repeat
      writeln(soubor,radkacel);
      readln(soubor2,radkacel)
     until eof(soubor2);
     write(soubor,radkacel);
     write(soubor,chr(26));
     reset(soubor);
     close(soubor2);
     DelRadek;
     NajdiEnd;
     Close(soubor);
     num_line:=1;
     cursorpos:=1;
     block_b:=1;
     block_k:=0;
     CopyBlock; {vytvori inicializacni blok}
     Vypis(1);
    end
   else chyba:=2;
  end;
 if chyba<>0 then
  begin
   Error(chyba);
   for f:=1 to 12 do userfname[f]:=pomufn[f];
   exit;
  end;
 inlinecom:=0;
 zradku:=1;
end;


procedure Save;
var strpin:string;
begin
 strpin:='SAVE ('+userfname+'):';
 InputRad(strpin);
 inlinecom:=3;
 zradku:=length(strpin)+1;
end;

procedure Save2;
var soubor2:text;
    radkacel:string;
procedure SubRut;
begin
 {$I-}
  Rewrite(soubor2);
 {$I+}
 if IOResult=0 then
  begin
   Hlaseni('Saving...');
   Reset(soubor);
   for f:=1 to end_line-1 do
    begin
     readln(soubor,radkacel);
     writeln(soubor2,radkacel);
    end;
   readln(soubor,radkacel);
   write(soubor2,radkacel);
   write(soubor2,chr(26));
   Close(soubor2);
   Close(soubor);
   DelRadek;
{   Smazinfo;}
  end
 else chyba:=24;
end;

begin
 ZpracInp;
 if chyba=0 then
  begin
   Assign(soubor2,workdir+userfname);
   {$I-}
    Reset(soubor2);
   {$I+}
   if IOResult=0 then
    if SureQue('Overwrite') then
     begin
      Close(soubor2);
      SubRut;
      inlinecom:=0;
      zradku:=1;
     end
    else inlinecom:=3
   else
    begin
{     Close(soubor2);}
     SubRut;
    end;
  end;
 if chyba<>0 then {chyba ze SubRut!}
  begin
   Error(chyba);
   for f:=1 to 12 do userfname[f]:=pomufn[f];
   inlinecom:=0;
   zradku:=1;
   exit;
  end;
end;

procedure ZmenDir;
var strpin:string;
begin
 strpin:='Change dir to (full path):';
 InputRad(strpin);
 inlinecom:=4;
 zradku:=length(strpin)+1;
end;

procedure ZmenDir2;
var dir:string;
begin
 f:=0;
 repeat
  inc(f);
 until radka[f]=':';
 if radka[f+1]<>#0 then
  begin
   i:=0;
   repeat
    inc(f);
    inc(i);
    dir[i]:=radka[f];
   until radka[f]=#0;
   dir[0]:=chr(i-1);
   {$I-}
    ChDir(dir);
   {$I+}
   if IOResult<>0 then
     Error(22)
   else
    begin
     workdir:=OdstLom(dir)+lomitko;
     ChDir(OdstLom(sysdir));
    end;
  end;
 DelRadek;
 inlinecom:=0;
 zradku:=1;
end;

procedure ZpracInp;
var pripona:boolean;
begin
 pripona:=false;
 f:=0;
 repeat
  inc(f);
 until radka[f]=':';
 if radka[f+1]<>#0 then
  begin
   pomufn:=userfname;
   for i:=1 to 12 do userfname[i]:=' ';
   i:=0;
   repeat
    inc(i);
    inc(f);
    userfname[i]:=radka[f];
   until (radka[f]=#0) or (i=9) or (radka[f]='.');
   if radka[f]='.' then
   begin
    pripona:=true;
    if radka[f+1]<>#0 then
     begin
      userfname[i]:='.';
      userfname[i+1]:=radka[f+1];
      userfname[i+2]:=radka[f+2];
      userfname[i+3]:=radka[f+3];
      i:=i+4; f:=f+4;
     end
    else begin i:=i+4; f:=f+4; end;
   end;
   if not pripona then
    if radka[f]=#0 then
     begin
      userfname[i]:='.';
      userfname[i+1]:='a';
      userfname[i+2]:='s';
      userfname[i+3]:='m';
     end
    else chyba:=4;
 end;
end;


procedure UpravCText(odkud,kam:integer);
var {cradka:string[kradku];}
    counter:integer;

begin
 if odkud<=kam then
  begin
   num_line:=odkud;
   for counter:=odkud to kam do
    begin
     Hlaseni('Converting...');
     Editln;
 {    Reset(soubor);
     for i:=1 to num_line do
      readln(soubor,cradka);
     for i:=1 to length(cradka) do
      radka[i]:=cradka[i];}
     overwrite:=true;
     Enter;
     if KeyPressed then exit;
     ORadekNiz;
    end;
   Inforadek;
  end;
end;

procedure DefPolozky;
var strproinp:string;
    l,m,o:string[2];
    {j:integer;}
begin
 str(knavesti,l);
 str((kinstr-knavesti),m);
 str((koperand-kinstr),o);
 strproinp:='Label,instr.,operand ('+l+','+m+','+o+'):';
 InputRad(strproinp);
 inlinecom:=1;
 zradku:=length(strproinp)+1;
end;

procedure DefPolozky2;
var l,m,o:string[2];
    ll,lm,lo,c:integer;
    spatne:boolean;
begin
 l:='';
 m:='';
 o:='';
 f:=0;
 repeat
  inc(f);
 until radka[f]=':';
 spatne:=false;
 i:=0;
 repeat
   inc(i);
   inc(f);
   if (radka[f]>='0') and (radka[f]<='9') then l:=l+radka[f]
    else spatne:=true;
 until (radka[f]=',') or spatne or (i=3);
 if radka[f]=',' then spatne:=false
  else spatne:=true;
 if not spatne then
  begin
   i:=0;
   repeat
     inc(i);
     inc(f);
     if (radka[f]>='0') and (radka[f]<='9') then m:=m+radka[f]
      else spatne:=true;
   until (radka[f]=',') or spatne or (i=3);
   if radka[f]=',' then spatne:=false
    else spatne:=true;
   if not spatne then
    begin
     i:=0;
     repeat
       inc(i);
       inc(f);
       if (radka[f]>='0') and (radka[f]<='9') then o:=o+radka[f]
        else spatne:=true;
     until spatne or (i=3);
     if i<4 then spatne:=false
      else spatne:=true;
    end;
  end;
 if not spatne then
  begin
   val(l,ll,c); { konvertuje string l na cislo ll, chybny znak v c }
   val(m,lm,c);
   val(o,lo,c);
   if (ll+lm+lo<80) and (ll>4) and (lm>3) and (lo>5) then
     begin
      knavesti:=ll;
      kinstr:=lm+ll;
      koperand:=lo+ll+lm;
    end
   else spatne:=true;
   DelRadek;
  end;
 if spatne then
  begin
   DelRadek;
   Error(23);
  end;
 inlinecom:=0;
 zradku:=1;
end;

procedure InputRad(polozka:string);
{var spatne:boolean;}
begin
  DelRadek;
  GoToXY(1,25);
  for f:=1 to length(polozka) do
    radka[f]:=polozka[f];
  cursorpos:=length(polozka)+1;
  Vypcur;
end;

procedure CurHome;
begin
 cursorpos:=zradku;
 if radka[cursorpos]<>';' then
  begin
   pisb:=true;
  end
end;

procedure CurEnd;
begin
 f:=kradku;
 while (radka[f]<' ') and (f>1) do
  dec(f);
 if (f<>1) and (f<>kradku) then cursorpos:=f+1
 else if f=kradku then cursorpos:=kradku
      else cursorpos:=1;
end;

procedure PgDown;
begin
 if num_line<>end_line then
  begin
   for f:=num_line to num_line+19 do
    if num_line<end_line then inc(num_line);
   Vypis(1);
  end;
end;

procedure PgUp;
begin
 if num_line<>1 then
  begin
   for f:=num_line downto num_line-19 do
    if num_line>1 then dec(num_line);
   Vypis(1);
  end;
end;

procedure NewText;
var pomstr:string;
begin
 if SureQue('Clear text') then
  begin
   Rewrite(soubor);
   Reset(soubor);
   NajdiEnd;
   Close(soubor);
   num_line:=1;
{   cursorpos:=1;}
   pomstr:='NONAME##.ASM';
   for f:=1 to 12 do userfname[f]:=pomstr[f];
   block_b:=1;
   block_k:=0;
   CopyBlock; {vytvori inicializacni blok}
   Vypis(1);
  end;
end;

procedure Cursor (visible:boolean);
var regs: registers;
begin
{ if visible then CursorOn
 else CursorOff;}
 if visible then
{  asm
   mov ah,1;
   mov ch,10;
   mov cl,11;
   int 16;
  end}
  begin
   regs.ax := $0100;              { Service $01 }
   regs.cl := $20;
   regs.ch := regs.ch or $DF;      { enable cursor }
   Intr ($10, regs);             { ROM BIOS video driver interrupt }
  end
 else
{  asm
   mov ah,1;
   mov ch,1;
   mov cl,0;
   int 16;
  end;}
  begin
   regs.ax := $0100;              { Service $01 }
   regs.cl := $20;
   regs.ch := regs.ch or $20;      { disable cursor }
   Intr ($10, regs);             { ROM BIOS video driver interrupt }
  end;
end;

procedure ExitTE;
begin
 if SureQue('Exit') then
  begin
{   done:=true;}
   Hlaseni('Exiting...');
   delay(400);
{   close(soubor);}
   erase(soubor);
   erase(block);
   Cursor(true);
   LowVideo;
   ClrScr;
   Halt
  end
end;

procedure Zarad(var poinasezn:POneRec; cozarad:string); forward;
procedure VypisSezn(var poinasezn:POneRec); forward;

procedure Init;
var pomstr:string[10];
    {i:integer;}
    config:text;
    {pompoi,pom2poi:POneRec;}

procedure HaltEnd;
begin
 Cursor(true);
 Halt;
end;

begin
 Cursor(false);
 writeln;
 writeln('Starting TurboEdit 2.0b, Copyright (C) 1999, Adam Pribyl');
 delay(500);
 GetDir(0,sysdir);
 if sysdir[length(sysdir)]<>lomitko then sysdir:=sysdir+lomitko;
 Assign(config,'tasme.cfg');
{$I-}
 Reset(config);
{$I+}
 if IOResult<>0 then
  begin
   writeln('FATAL: Config file "tasme.cfg" missing.');
   HaltEnd;
  end;
 Close(config);
 pomufn:='NONAME##.ASM';
 jmeno:=sysdir+'newasm.as~';
 if Cfg('[TYPE]')='Tasm' then edtypt:=true
 else edtypt:=false;
 workdir:=Cfg('[WORKDIR]');
 jinstdtb:=Cfg('[INSDTB]');
{diky lomitku nefunguje v ROOTu!!!}
 {$I-}
  ChDir(OdstLom(workdir));
 {$I+}
 if (IOResult<>0) and (workdir<>' ') then
  begin
   writeln('There is not [WORKDIR] "',workdir,'" directory. Make it?');
   writeln('Current:',sysdir);
   Ch:=ReadKey;
   if (Ch='y') or (Ch='Y') then
    begin
     {$I-}
      MkDir(OdstLom(workdir));
     {$I+}
     if IOResult<>0 then
      begin
       writeln('Cannot make work directory.');
       HaltEnd;
      end;
    end
   else workdir:=sysdir;
  end
 else ChDir(OdstLom(sysdir)); {pouze navrat do spousteciho adresare}
 if workdir[length(workdir)]<>lomitko then workdir:=workdir+lomitko;
 Assign(instdtb,jinstdtb);
 {$I-}
  Reset(instdtb);
 {$I+}
 if IOResult<>0 then
  begin
   writeln('FATAL: Cannot open istruction set database.');
   writeln('     : Section [INSDTB] in configfile missing?');
   HaltEnd
  end
 else
  begin
   poinstset:=nil;
   repeat
    readln(instdtb,pomstr);
    for f:=1 to length(pomstr) do {downcase}
     if (pomstr[f]>='A') and (pomstr[f]<='Z') then pomstr[f]:=chr(ord(pomstr[f])+32);
    Zarad(poinstset, pomstr);
   until eof(instdtb);
   Close(instdtb)
  end;
 Assign(soubor,jmeno);
 {$I-}
  Rewrite(soubor);
 {$I+}
 if IOResult<>0 then
  begin
   writeln('FATAL: Cannot make temp file.');
   HaltEnd;
  end;
 Close(soubor);
 Reset(soubor);
 for f:=1 to 10 do posledni[f]:=1;
 for f:=1 to 12 do userfname[f]:=pomufn[f];
 NajdiEnd;
 Close(soubor);
 block_b:=1;
 block_k:=0;
 CopyBlock; {vytvori inicializacni blok - tedy v tomto pripade zadny :) }
 num_line:=1;
 cursorpos:=1;
 Vypis(1);
 pisb:=true;
 overwrite:=false;
 done:=false;
 contvz:=true;
 for f:=1 to kradku do radka[f]:=#0;
 for f:=1 to hled_retez+1 do cohled[f]:=' ';
 cohled[0]:=#0;
end;

function RadkaCh(tradka:string; posn:integer{;var pole:array of string;PP:integer}):boolean;
var {posn,posin:integer;}
    instruct:string;
    {i:integer;}
   { stop,}indtb:boolean;
   pompoi:POneRec;

procedure TestZn(x,y:integer); { interni procedura funkce RadkaCh }
begin
 if (tradka[y]>='A') and (tradka[y]<='Z') then tradka[y]:=chr(ord(tradka[y])+32);
 if x=1 then if (tradka[y]<instruct[x]) then indtb:=false; {skonci kdyz je napsana instrukce
                                                                              vetsi nez prohledvana}
 if (tradka[y]=instruct[x]) then
  if (instruct[x+1]<>#13) or ((tradka[y+1]<>#0) and (tradka[y+1]<>' ')) then
    begin
     inc(y);
     inc(x);
     TestZn(x,y)
    end
  else indtb:=true
 else
  indtb:=false
end;

begin
if not komentar(tradka,posn) then
begin
  while (posn<>1) and (tradka[posn-1]<>' ') do dec(posn);
{  i:=1;}
  pompoi:=poinstset;
  repeat
   instruct:=pompoi^.tretez+#13;
{   instruct:=poleins[i]+#13;  }
   pompoi:=pompoi^.dalsi;
{   inc(i);}
   TestZn(1,posn);
  until indtb or (pompoi=nil);{PINST=pocet intrukci v instdtb}
  if indtb then
    begin {write('in    ');} RadkaCh:=true end
  else begin {write('not in');} RadkaCh:=false end
end
else RadkaCh:=false
end;


procedure ObnovObr;
begin
 Window(1,1,80,25);
 Vypis(1);
 Vypcur
end;

procedure Ramecek(x1,y1,x2,y2:integer;text:string);
var c:integer;
begin
  c:=x1+1;
  gotoxy(1,1);
  Write('');
  gotoxy(1,y2-y1+1);
  Write('');
  While(c<x2) do
  begin
    gotoxy(c-x1+1,1);
    Write('');
    gotoxy(c-x1+1,y2-y1+1);
    Write('');
    inc(c);
  end;
  gotoxy(x2-x1+1,1);
  Write('');
  Window(x1,y1,x2+1,y2);
  gotoxy(x2-x1+1,y2-y1+1);
  Write('');
  c:=y1+1;
  while(c<y2) do
  begin
    gotoxy(1,c-y1+1);
    Write('');
    gotoxy(x2-x1+1,c-y1+1);
    Write('');
    inc(c);
  end;
end;


procedure Okno(x1,y1,x2,y2,barva_ok,barva_ram:integer;text:string);
var zac_tit,a,b,cykl:integer;
begin
  a:=length(text);
  if a>(x2-x1-3) then
   begin
    b:=a-(x2-x1-3);
    zac_tit:=3;
    text[1]:='.';
    text[2]:='.';
    for cykl:=3 to (x2-x1-3) do text[cykl]:=text[cykl+b];
    text[0]:=chr(x2-x1-3);
   end
  else
   begin
    zac_tit:=((x2-x1) div 2)-(a div 2);
    if zac_tit/2=zac_tit div 2 then zac_tit:=zac_tit+1
     else zac_tit:=zac_tit+2;
   end;
{  Uloz_scr;}
  Window(x1,y1,x2,y2);
  TextBackground(barva_ok);
  TextColor(barva_ram);
  Clrscr;
  Ramecek(x1,y1,x2,y2,text);
  gotoxy(zac_tit,1);
  TextBackground(7);
  TextColor(0);
  Write(text);
  Window(x1+1,y1+1,x2-1,y2);
end;

procedure Load3; forward;
procedure ZmenDir3; forward;
procedure Hledej; forward;
procedure ChgAdjust; forward;
procedure SpustExe; forward;

procedure HlavniMenu;

const polozek=5; {polozek v menu}
      CoZv=0;    {barva 'kursoru'}
      CoPo=7;    {barva podkladu}
      CoTx=0;    {barva textu}

var cis_menu,cis_okna,cis_scr,cis_hie{,cykl}:integer;
    text:string;
    p:Boolean;
    Znak:char;
    mnu1:array [1..20] of string;


procedure Menu(x1,y1,barva_ok,barva_ram,barva_pod,poc_pol:integer;text:string);
var {zac_txt,}cykl:integer;
    {Znak2:char;}
    x2,y2:integer;
    pomposl:byte;

begin
  case posledni[1] of {ktere polozky pole posledni pro vybrane menu}
   1: pomposl:=2;
   2: pomposl:=3;
   3: pomposl:=4;
   4: pomposl:=5;
   5: pomposl:=6;
  end;
  x2:=0;
  for cykl:=1 to poc_pol do
    if x2<length(mnu1[cykl]) then x2:=length(mnu1[cykl]);
  for cykl:=1 to poc_pol do
    while x2>length(mnu1[cykl]) do
     mnu1[cykl]:=mnu1[cykl]+' ';
  x2:=x2+x1+1;
  y2:=y1+poc_pol+1;
{  Uloz_scr;}
  cykl:=1;
  Okno(x1,y1,x2,y2,barva_ok,barva_ram,text);
  while (cykl<poc_pol+1) do
  begin
    if cykl=posledni[pomposl] then
     begin Textbackground(barva_pod); TextColor(barva_ok); end
    else
     begin Textbackground(barva_ok); TextColor(barva_ram); end;
    gotoxy(1,cykl);
    Write(mnu1[cykl]);
    inc(cykl);
  end;
  p:=false;
  gotoxy(1,posledni[pomposl]);
  while (Znak<>#27) and not p do
    begin
      cykl:=posledni[pomposl];
      repeat
      until KeyPressed;
      znak:=readkey;
      if znak=#13 then exit;
      if Znak=#0 then Znak:=readkey;
      if Znak=#80 then inc(posledni[pomposl]);
      if Znak=#72 then dec(posledni[pomposl]);
      if posledni[pomposl]=0 then posledni[pomposl]:=poc_pol;
      if posledni[pomposl]=poc_pol+1 then posledni[pomposl]:=1;
      if (znak=#77) or (znak=#75) then  p:=true;
      gotoxy(1,cykl);
      Textbackground(barva_ok);
      TextColor(barva_pod);
      Write(mnu1[cykl]);
      gotoxy(1,posledni[pomposl]);
      Textbackground(barva_pod);
      TextColor(barva_ok);
      Write(mnu1[posledni[pomposl]]);
{      TextColor(barva_pod);}
{      p:=False;}
    end;
    {Uloz_menu(x1,y1,x2,y2,barva_ok,barva_ram,barva_pod,zac_tit,poc_pol,text);}
end;

procedure MenuFile;
begin
 repeat
 mnu1[1]:='  New';
 mnu1[2]:='  Load';
 mnu1[3]:='  Save';
 mnu1[4]:='  ChangeDir  ';
 mnu1[5]:='  DOS shell';
 mnu1[6]:='  Exit  ';
 text:=' File ';
 Menu(2,2,CoPo,CoTx,CoZv,6,text);
 if (znak<>#27) and not p then
  case posledni[2] of
    1: begin
        ObnovObr;
        NewText;
        znak:=#27
       end;
    2: begin
        Load3;
        znak:=#27
       end;
    3: begin
        ObnovObr;
        Save;
        znak:=#27;
       end;
    4: begin
        ZmenDir3;
        p:=true
       end;
    5: begin
        ObnovObr;
        ClrScr;
        Cursor(true);
        LowVideo;
        ClrScr;
        if getenv('comspec')='' then
         begin
          writeln('Can''t find shell!');
          Cursor(false);
          waitkey;
         end
        else
         begin
          writeln('Type EXIT to return to Turbo Edit...');
{        TextColor(7);
        TextBackGround(0);}
          Exec(getenv('comspec'),'');
          Cursor(false);
         end;
        ObnovObr;
        znak:=#27
       end;
    6: begin
        ObnovObr;
        ExitTE;
        znak:=#27
       end;
  end;
{  Obnov_scr;}
 until (znak=#27) or p;
end;

procedure MenuEdit;
begin
 repeat
 mnu1[1]:='  EditLine';
 mnu1[2]:='  DeleteLine';
 mnu1[3]:='  DeletePrompt  ';
 mnu1[4]:='  ChngIOmode';
 text:=' Edit ';
 Menu(8,2,CoPo,CoTx,CoZv,4,text);
 if (znak<>#27) and not p  then
  case posledni[3] of
    1: begin
        ObnovObr;
        Editln;
        znak:=#27
       end;
    2: begin
        ObnovObr;
        SmazLine;
        znak:=#27
       end;
    3: begin
        ObnovObr;
        DelRadek;
        znak:=#27
       end;
    4: begin
        ObnovObr;
        ChgOI;
        znak:=#27;
       end
  end;
{  Obnov_scr;}
 until (znak=#27) or p;
end;

procedure MenuOptions;
begin
 repeat
 mnu1[1]:='  ChngColums';
 mnu1[2]:='  ConverText';
 mnu1[3]:='  Search';
 if contvz then mnu1[4]:='  Adjust On' else mnu1[4]:='  Adjust Off';
 if edtypt then mnu1[5]:='  EdType Tasm  ' else mnu1[5]:='  EdType Norm  ';
 text:=' Options ';
 Menu(16,2,CoPo,CoTx,CoZv,5,text);
 if (znak<>#27) and not p  then
  case posledni[4] of
    1: begin
        ObnovObr;
        DefPolozky;
        znak:=#27
       end;
    2: begin
        ObnovObr;
        UpravCText(1,end_line);
        znak:=#27
       end;
    3: begin
        ObnovObr;
        Hledej;
        znak:=#27
       end;
    4: begin
        ObnovObr;
{        ChgAdjust;}
        if contvz then contvz:=false else contvz:=true;
        znak:=#27
       end;
    5: begin
        ObnovObr;
        if edtypt then edtypt:=false else edtypt:=true;
        znak:=#27
       end;
  end;
{  Obnov_scr;}
 until (znak=#27) or p;
end;

procedure MenuTools;
begin
 repeat
 mnu1[1]:='  ASM';
 mnu1[2]:='  LINK';
 mnu1[3]:='  Exec';
 mnu1[4]:='  DEBUG  ';
{ mnu1[5]:='  Debug'; Tasm+tlink+td souboru}
 text:=' Tools ';
 Menu(29,2,CoPo,CoTx,CoZv,4,text);
 if (znak<>#27) and not p  then
  case posledni[5] of
    1: begin
        ObnovObr;
        SpustTasm;
        znak:=#27
       end;
    2: begin
        ObnovObr;
        SpustTlink;
        znak:=#27
       end;
    3: begin
        ObnovObr;
        SpustExe;
        znak:=#27;
       end;
    4: begin
        ObnovObr;
        SpustTd;
        znak:=#27;
       end;
  end;
{  Obnov_scr;}
 until (znak=#27) or p;
end;

procedure AboutOkno;
begin
  Okno(20,10,60,17,CoPo,CoTx,' About ');
  writeln;
  writeln('           TurboEdit 2.0b');
  writeln('      assembler source code editor');
  writeln('        (C) 1999 Adam Pribyl');
  writeln;
  write('                ');
  TextBackground(CoZv);
  TextColor(CoPo);
  write('  OK  ');
  TextBackground(CoPo);
  TextColor(CoTx);
  repeat until KeyPressed;
  ReadKey;
end;

procedure Help;
begin
 repeat
 mnu1[1]:='  Help';
 mnu1[2]:='  About  ';
 text:=' Help ';
 Menu(38,2,CoPo,CoTx,CoZv,2,text);
 if (znak<>#27) and not p  then
  case posledni[6] of
    1: begin
         ObnovObr;
         HelpPage;
         znak:=#27
       end;
    2: begin
        ObnovObr;
        AboutOkno;
        znak:=#27;
       end;
  end;
{  Obnov_scr;}
 until (znak=#27) or p;
end;

{zacatek hlavniho menu}
begin
 p:=false;
 cis_menu:=0;
 cis_okna:=0;
 cis_scr:=0;
 cis_hie:=0;
 repeat
  if p then ObnovObr;
  NormVideo;
  TextBackground(CoPo);
  TextColor(CoTx);
  mnu1[1]:='  File  ';
  mnu1[2]:='  Edit  ';
  mnu1[3]:='  Options  ';
  mnu1[4]:='  Tools  ';
  mnu1[5]:='  Help  ';
  GotoXY(1,1);
  for f:=1 to 80 do write(' ');
  GotoXY(1,1);
  for f:=1 to polozek do
    if f=posledni[1] then
     begin
      TextBackGround(CoZv);
      TextColor(CoPo);
      write(mnu1[f]);
      TextBackGround(CoPo);
      TextColor(CoTx);
     end
    else write(mnu1[f]);
   if not p then
    begin
     repeat
     until KeyPressed;
     Znak:=Readkey;
    end;
   if p or (znak=#13) then
     case posledni[1] of
      1: MenuFile;
      2: MenuEdit;
      3: MenuOptions;
      4: MenuTools;
      5: Help;
     end;
   if znak=#0 then znak:=readkey;
   if znak=#77 then
    if posledni[1]<>polozek then inc(posledni[1])
     else posledni[1]:=1;
   if znak=#75 then
    if posledni[1]<>1 then dec(posledni[1])
     else posledni[1]:=polozek;

 until znak=#27;
 ObnovObr;
end;

procedure PosuvSeznam(var poinadir:POneRec; var radkacel:string);
var aktrad,ardir:integer;
    konecdir:integer;
    pompoi:POneRec;
{    pompocdir:integer;}

begin
 aktrad:=1;
 Okno(5,3,20,24,7,0,workdir);
 aktrad:=1;
 ardir:=1;
 konecdir:=32767; {directory muze mit max integer polozek}
 repeat
  pompoi:=poinadir;
{  pompocdir:=1;}
  for f:=1 to ardir-1 do
   begin
    radkacel:=pompoi^.tretez;
    pompoi:=pompoi^.dalsi;
{    inc(pompocdir);}
   end;
  f:=1;
  GotoXY(1,1);
  while (pompoi<>nil) and (f<21) do
   begin
    if f=aktrad then
     begin TextBackGround(0); TextColor(7) end
    else
     begin TextBackGround(7); TextColor(0) end;
     radkacel:=pompoi^.tretez;
     pompoi:=pompoi^.dalsi;
     while length(radkacel)<14 do radkacel:=radkacel+' ';
    write(radkacel);
{    inc(pompocdir);}
    inc(f);
   end;
   if pompoi=nil then konecdir:=ardir+f-1;
   repeat
   until KeyPressed;
   Ch:=ReadKey;
   if Ch=#13 then
    if poinadir<>nil then
     begin
{     if konecdir>1 then
      begin}
 {      Reset(dirlist);}
       pompoi:=poinadir;
       for f:=1 to ardir+aktrad-1 do
        begin
         radkacel:=pompoi^.tretez;
         pompoi:=pompoi^.dalsi;
        end;
{      end
      else Ch:=#27;}
     end
    else radkacel:='';
   if Ch=#0 then Ch:=ReadKey;
   if Ch=#72 then
    begin
     if (ardir>1) and (aktrad=1) then dec(ardir);
     if aktrad>1 then dec(aktrad);
    end;
   if Ch=#80 then
    begin
     if (aktrad=20) and (aktrad+ardir<konecdir) then inc(ardir);
     if (aktrad<20) and (aktrad+ardir<konecdir) then inc(aktrad);
    end;
 until (Ch=#27) or (Ch=#13);
end;

{procedure Setrid(var dirlist:text);
var
  i, j, x, y: string;
begin
  i := l; j := r; x := a[(l+r) DIV 2];
  repeat
    while a[i] < x do i := i + 1;
    while x < a[j] do j := j - 1;
    if i <= j then
    begin
      y := a[i]; a[i] := a[j]; a[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Setrid(l, j);
  if i < r then Setrid(i, r);
end;}

procedure ZrusDirList(var poinadir:POneRec);
var pompoi:POneRec;
begin
 while poinadir<>nil do
  begin
   pompoi:=poinadir^.dalsi;
   Dispose(poinadir);
   poinadir:=pompoi;
{   dec(pocdir);}
 end
end;

procedure VypisSezn(var poinasezn:POneRec); {pouze ladici}
var pompoi:POneRec;
    count:integer;
begin
 pompoi:=poinasezn;
 count:=0;
 repeat
  writeln(pompoi^.tretez);
  pompoi:=pompoi^.dalsi;
  inc(count);
  if count/24=int(count/24) then waitkey;
 until pompoi=nil;
end;

procedure Zarad(var poinasezn:POneRec; cozarad:string);
var pompoi, pom2poi, pom3poi:POneRec;
    pomstr:string;
    done:boolean;

begin
 if poinasezn<>nil then
  begin
   pompoi:=poinasezn;
   New(pom2poi);
   pom2poi^.tretez:=cozarad;
   pomstr:=pompoi^.tretez;
   if cozarad<pomstr then    {pripad kdy by byl prvek nejvetsi ze vsech = zmena pocatku}
    begin
     pom2poi^.dalsi:=poinasezn;
     poinasezn:=pom2poi;
    end
   else
    begin
     pom3poi:=pompoi;
     pompoi:=pompoi^.dalsi;
     pomstr:=pompoi^.tretez;
     done:=false;
     repeat
      if pompoi<>nil then
       if cozarad<pomstr then
        begin
         pom2poi^.dalsi:=pompoi;
         pom3poi^.dalsi:=pom2poi;
         done:=true;
        end
       else
        begin
         pom3poi:=pompoi;
         pompoi:=pompoi^.dalsi;
         pomstr:=pompoi^.tretez;
        end
      else
       begin
        pom3poi^.dalsi:=pom2poi;
        pom2poi^.dalsi:=nil;
        done:=true;
       end;
     until done;
{     if pompoi=nil then
      begin
       pom3poi^.dalsi:=pom2poi;
       pom2poi^.dalsi:=nil;
      end;}
    end;
  end
 else
  begin
   New(poinasezn);
   poinasezn^.tretez:=cozarad;
   poinasezn^.dalsi:=nil;
  end;
end;


procedure Load3;

var soubor2:text;
    radkacel:string;
    DirInfo:SearchRec;
{    pocdir:integer;} {pocitadlo kolik je adresaru}
    poinadir{, pompoi, pom2poi}: POneRec;

begin
{ radkacel:=sysdir+'tedit$$$.tmp';
 Assign(dirlist,radkacel);
 Rewrite(dirlist);}

 ChDir(OdstLom(workdir));
 FindFirst('*.*', archive, DirInfo);
{ pocdir:=1;}
{ New(pompoi);
 poinadir:=pompoi;}
 poinadir:=nil;
 while DosError = 0 do
  begin
   Zarad(poinadir,DirInfo.Name);
{   pompoi^.Name:=DirInfo.Name;
   pom2poi:=pompoi;
   New(pompoi);
   pom2poi^.dalsi:=pompoi;}
{   inc(pocdir);}
   FindNext(DirInfo);
  end;
{ pom2poi^.dalsi:=nil;
 Dispose(pompoi);}
 Chdir(OdstLom(sysdir));
 PosuvSeznam(poinadir,radkacel);
 if (Ch<>#27) and (radkacel<>'') then
  begin
   while length(radkacel)<12 do radkacel:=radkacel+' ';
   for f:=1 to 12 do userfname[f]:=radkacel[f];
   chyba:=0;
   Assign(soubor2,workdir+userfname);
   {$I-}
    Reset(soubor2);
   {$I+}
   if IOResult=0 then
    begin
     ObnovObr;
     Hlaseni('Loading...');
     rewrite(soubor);
     readln(soubor2,radkacel);
     repeat
      writeln(soubor,radkacel);
      readln(soubor2,radkacel)
     until eof(soubor2);
     write(soubor,radkacel);
     write(soubor,chr(26));
     reset(soubor);
     Close(soubor2);
     DelRadek;
     NajdiEnd;
     Close(soubor);
     num_line:=1;
     cursorpos:=1;
     block_b:=1;
     block_k:=0;
     CopyBlock; {vytvori inicializacni blok}
     Vypis(1);
    end
   else chyba:=2;
  if chyba<>0 then
   begin
    ObnovObr;
    Error(chyba);
    for f:=1 to 12 do userfname[f]:=pomufn[f];
    exit;
   end
  end;
 ZrusDirList(poinadir);
{   Close(dirlist);
   Erase(dirlist)
 else ObnovObr;}
end;

procedure ZmenDir3;
var radkacel:string;
    DirInfo:SearchRec;
    {pocdir:integer;} {pocitadlo kolik je adresaru}
    poinadir{, pompoi, pom2poi}: POneRec;

begin
 repeat
{  radkacel:=sysdir+'tedit$$$.tmp';
  Assign(dirlist,radkacel);
  Rewrite(dirlist);}

  Chdir(OdstLom(workdir));
  FindFirst('*', directory, DirInfo);

{  while DosError = 0 do
  begin
    if (Dirinfo.Size=0) and (Dirinfo.Name<>'.') then
     Writeln(dirlist,DirInfo.Name+'/');
    FindNext(DirInfo);
  end;
  PosuvSeznam(dirlist,radkacel);}

{  pocdir:=1;}
{  New(pompoi);}
  poinadir:=nil;
  while DosError = 0 do
   begin
    if (Dirinfo.Name<>'.') then
     begin
      radkacel:=DirInfo.Name;
      radkacel:=radkacel+lomitko;
      Zarad(poinadir, radkacel);
{      pompoi^.Name:=radkacel;
      pom2poi:=pompoi;
      New(pompoi);
      pom2poi^.dalsi:=pompoi;}
{      inc(pocdir);}
     end;
    FindNext(DirInfo);
   end;
{   pom2poi^.dalsi:=nil;
   Dispose(pompoi);}
{  Chdir(OdstLom(sysdir));}
  PosuvSeznam(poinadir,radkacel);
  radkacel:=OdstLom(radkacel);
  if Ch<>#27 then Chdir(OdstLom(radkacel));
  GetDir(0,workdir);
  if workdir[length(workdir)]<>lomitko then workdir:=workdir+lomitko;
  ZrusDirList(poinadir);
{  Close(dirlist);
  Erase(dirlist);}
 until Ch=#27;
end;

procedure Hledej;
var strpin:string;
begin
 strpin:='SEARCH ('+cohled+'):';
 InputRad(strpin);
 inlinecom:=7;
 zradku:=length(strpin)+1;
end;

procedure Hledej2;
var cradka:string;
    i:byte;

 function JeVRadku (inrad:string):boolean; { interni funkce Hledej2 }
 var {pomstr:string;}
    pocit:integer;
    vradce:boolean;

  procedure TestZn(x,y:integer); { interni procedura funkce JeVRadku }
  begin
   if (inrad[y]=cohled[x]) then
    if (cohled[x+1]<>#13) then
    begin
      inc(y);
      inc(x);
      TestZn(x,y)
    end
    else vradce:=true
   else
    vradce:=false
  end;

 begin
  if length(inrad)<>0 then
   begin
    pocit:=0;
    repeat
     inc(pocit);
     TestZn(1,pocit);
    until (pocit>length(inrad)-1) or vradce;
    if vradce then JeVRadku:=true else JeVRadku:=false
   end
  else JeVradku:=false;
 end;

begin
 f:=0;
 repeat
  inc(f);
 until radka[f]=':';
 if radka[f+1]<>#0 then
  begin
   i:=0;
   repeat
    inc(f);
    inc(i);
    cohled[i]:=radka[f];
   until (radka[f+1]=#0) or (i=hled_retez);{max delka hledaneho retezce}
   cohled[0]:=chr(i);
  end;
   cohled:=cohled+#13;
   Reset(Soubor);
   i:=0;
   repeat
    inc(i);
    readln(soubor,cradka);
   until i=num_line;
   repeat
    inc(i);
    readln(soubor,cradka);
   until eof(soubor) or JeVRadku(cradka);
   if JeVRadku(cradka) then num_line:=i
    else Error(12);
 cohled[0]:=chr(ord(cohled[0])-1);
 DelRadek;
 Vypis(1);
 inlinecom:=0;
 zradku:=1;
end;

procedure ChgAdjust;

begin
 if contvz then contvz:=false else contvz:=true;
end;

procedure SpustExe;
var strpin:string;

begin
 strpin:='Exec ('+userfname+'):';
 InputRad(strpin);
 inlinecom:=8;
 zradku:=length(strpin)+1;
end;

procedure SpustExe2;
var CmdLine:string;
    pomprom:string;

begin
 SubRut2(CmdLine,pomprom,'exe');
 RunProg(workdir+pomprom,CmdLine);
 DelRadek;
 Vypis(1);
end;

procedure CopyBlock;
var cradka:string[kradku];
    S:string;

begin
 Reset(soubor);
 Assign(block,sysdir+'block$$$.tmp');
 {$I-}
 Rewrite(block);
 {$I+}
 if IOResult=0 then
 if (block_b<=block_k)then
  begin
   for f:=1 to block_b-1 do readln(soubor,cradka);
   {blok by mel byt vzdy uvnitr souboru, neni treba testovat konec souboru}
   Str(block_k-block_b+1, S);
   writeln(block, S);
   for f:=block_b to block_k do
    begin
     readln(soubor,cradka);
     writeln(block,cradka);
    end;
   Close(block);
  end
 else
  begin
    S:='0';
    writeln(block, S);
    Close(block);
  end
 else Error(24);
 Close(soubor);
end;

procedure PasteBlock;
var {cradka:string[kradku];}
    rad_count, code:integer;

begin
{ Reset(soubor);}
 Assign(block,sysdir+'block$$$.tmp');
 Reset(block); {blok jiz existuje, vytvori ho init, load nebo new}
 readln(block, radkains);
 Val(radkains, rad_count, code);{code kuli chybe pri prevodu - nevyuzito}
 if rad_count<>0 then
  begin
   readln(block, radkains);
   DelInsRadek(2);
   block_b:=num_line;
   block_k:=num_line;
   if rad_count=1 then Vypis(1); {kladivo na pripad ze blok je jeden radek}
   code:=0;
   for code:=2 to rad_count do
    begin
     readln(block, radkains);
     DelInsRadek(2);
    end;
  end;
{ Close(soubor);}
 Close(block);
end;

Procedure DelBlock(mov:boolean);
var pomnl:integer;
    pomc:integer;

begin
 pomnl:=num_line;
 pomc:=block_k;
 num_line:=block_b;
 repeat
  SmazLine;
 until block_b-1=block_k;
 if pomnl<=block_b then num_line:=pomnl
 else if (pomnl>block_b) and (pomnl<=pomc) then num_line:=block_b
      else if pomnl>pomc then num_line:=pomnl-(pomc-block_b+1);
 if not mov then CopyBlock;
 Vypis(1);
end;


Procedure MoveBlock;
{var zal_b, zal_k:integer;}

begin
{ zal_b:=block_b;
 zal_k:=block_k;}
 if (block_k>=block_b) and ((num_line<block_b) or (num_line>block_k)) then
  begin
   DelBlock(True); {delame move}
   PasteBlock;
  end
end;

{Hlavni Program}
begin
 Init;
1:repeat
   Vypcur;
   HighVideo;
   repeat
    TimeObr;
    C_Radku;
   until KeyPressed;
   i:=mem[$0000:$0417];         {stavovy bajt klavesnice}
   i:=i and 4;
{FIXME   i:=GetKeyShiftState;}
   Ch:=ReadKey;
   if i=4 then                  {test kombinace Ctrl+neco}
{   if ssCtrl in i then}
    case Ch of
     #2: begin block_b:=num_line; CopyBlock; Vypis(1); end;     {Ctrl+b}
     #4: DelBlock(false);                                       {Ctrl+d jen smazat block}
     #11: begin block_k:=num_line; CopyBlock; Vypis(1); end;    {Ctrl+k}
{     #3: CopyBlock; - neni potreba volat extra klavesou}
     #21: begin UpravCText(block_b,block_k); CopyBlock; end;    {Ctrl+u}
     #3: PasteBlock;                                            {Ctrl+c}
     #24: MoveBlock;                                            {Ctrl+x}
     #25: SmazLine;                                             {Ctrl+y}
     #13: ; {kuli enteru}
    end {case Ch of}
   else
   begin
     case Ch of
       #0:           { Function keys }
       begin
         Ch:=ReadKey;
         case Ch of
           #120: Editln;         { Alt-1 }
           #45: ExitTE;          { Alt-x }
           #17: ChgOI;           { Alt-w }
{           #32: SmazLine;}        { Alt-d - nahrazeno Ctrl+y}
           #72: ORadekVys;
           #80: ORadekNiz;
           #77: Doprava;
           #75: Doleva;
           #16: DelRadek;        { Alt-q }
           #83: Del;
           #46: DefPolozky;      { Alt-c }
           #22: UpravCText(1,end_line);      { Alt-u }
           #71: CurHome;
           #79: CurEnd;
           #38: Load;            { Alt-l }
           #31: Save;            { Alt-s }
           #59: HelpPage;        { F1 }
           #30: ZmenDir;         { Alt-a }
           #49: NewText;         { Alt-n }
           #81: PgDown;          { PageDown }
           #73: PgUp;            { PageUp }
           #20: SpustTasm;       { Alt-t }
           #23: SpustTlink;      { Alt-i }
           #32: SpustTd;         { Alt-d }
           #68: HlavniMenu;      { F10 }
           #19: Hledej;          { Alt-r }
           #18: SpustExe         { Alt-e }
         end; {case Ch of}
       end; {#0}
       #9 : Tabulator;
{      #32: Mezernik;}
       #13: Enter;
       #8:  Backspace;
       else {case Ch of}
       begin
        if (ord(Ch)>31) and pisb then
        begin
{         if (Ch=';') or (Ch='''') then Strednik;}
{         if chyba<>0 then begin Error(chyba); GoTo 1; end;}
          if not komentar2(radka,cursorpos) and (Ch<>';') and (Ch<>'''') then
          radka[cursorpos]:=Ch
          else {if (radka[cursorpos]<>';') and (radka[cursorpos]<>'''') then} Strednik;
          if (cursorpos<kradku) and pisb then inc(cursorpos)
          else begin pisb:=false; Sound(330); delay(50); NoSound; end;
        end
        else begin Sound(330); Delay(50); NoSound; end;
       end {case Ch of}
   end; {else}
   end; {if i=4 then}
 until Done;
 close(soubor);
 erase(soubor);
 Cursor(true);
 NormVideo;
 ClrScr;
end.
